package chatcorba;
import org.omg.CosNaming.*;
import java.lang.*;
import org.omg.PortableServer.*;
import com.inprise.vbroker.orb.*;
import com.inprise.vbroker.PortableServerExt.BindSupportPolicyValue;
import com.inprise.vbroker.PortableServerExt.BindSupportPolicyValueHelper;
import java.io.*;

/**
 * Title:        Chat en CORBA
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      MIAGe
 * @author L & D
 * @version 1.0
 */

public class ClientServant {


  public static void main(String args[])
  {

    try{

        // On intialise l'orb
        org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args,null);

        /**
         * On rcupere en premier lieu la rfrence initiale du service de nommage
         * c'est  dire la rfrence initalie dont le nom est NameService
         */
        org.omg.CORBA.Object racineObj = orb.resolve_initial_references("NameService");
        /**
         * On rcupre ensuite la racine de l'arbre de dsignation: l'annuaire est
         * hierarchis en catgorie et sous-catgories,
         * le tout formant l'arbre (ou graphe) de dsignation.
         */
        NamingContextExt racineArbre = NamingContextExtHelper.narrow(racineObj);

        //Rcupration du RootPOA
        POA rootPOA = POAHelper.narrow(orb.resolve_initial_references("RootPOA"));

        //On construit un nom  enregistrer
        org.omg.CosNaming.NameComponent [] tabNom = new org.omg.CosNaming.NameComponent[1];
        tabNom[0] = new org.omg.CosNaming.NameComponent(args[0],"");

        //Initilisation des polices
        org.omg.CORBA.Any any = orb.create_any();
        BindSupportPolicyValueHelper.insert(any,BindSupportPolicyValue.BY_INSTANCE);
        org.omg.CORBA.Policy bsPolicy = orb.create_policy(com.inprise.vbroker.PortableServerExt.BIND_SUPPORT_POLICY_TYPE.value,any);

        org.omg.CORBA.Policy [] policies = {rootPOA.create_lifespan_policy(LifespanPolicyValue.PERSISTENT),bsPolicy};

        //Cration et activation du POA
        org.omg.PortableServer.POA monPOA = rootPOA.create_POA("chatClientPOA",rootPOA.the_POAManager(),policies);

        //Cration d'un objet d'implmentation (servant)
        ChatClientImpl monChat = new ChatClientImpl(args[0]);

        //Affectation d'un ID  l'objet d'implmentation
        byte[] chatId = args[0].getBytes();

        //Activer le servant avec son Id dans notre POA
        monPOA.activate_object_with_id(chatId,monChat);

        //Activer le POAManager qui gre le rootPOA et notre POA
        rootPOA.the_POAManager().activate();

        //Enregistrement de l'objet dans le service de nommage
        racineArbre.rebind(tabNom,monPOA.servant_to_reference(monChat));

        System.out.println(monPOA.servant_to_reference(monChat)+" est pret");

        //en attente de requetes
        orb.run();

      }
      catch(Exception e){
        e.printStackTrace();
     }
  }
}