package agences.supermarche;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/gestionSupermarche/Agences/Agences/src/agences/supermarche.idl"
 * <li> <b>IDL Name</b>      ::supermarche::Caisse
 * <li> <b>Repository Id</b> IDL:supermarche/Caisse:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface Caisse {
  ...
};
 * </pre>
 */
public class CaissePOATie extends CaissePOA {
  private agences.supermarche.CaisseOperations _delegate;
  private org.omg.PortableServer.POA _poa;

  public CaissePOATie (final agences.supermarche.CaisseOperations _delegate) {
    this._delegate = _delegate;
  }

  public CaissePOATie (final agences.supermarche.CaisseOperations _delegate, 
                              final org.omg.PortableServer.POA _poa) {
    this._delegate = _delegate;
    this._poa = _poa;
  }

  public agences.supermarche.CaisseOperations _delegate () {
    return this._delegate;
  }

  public void _delegate (final agences.supermarche.CaisseOperations delegate) {
    this._delegate = delegate;
  }

  public org.omg.PortableServer.POA _default_POA () {
    if (_poa != null) {
      return _poa;
    } 
    else {
      return super._default_POA();
    }
  }

  /**
   * <pre>
   *   readonly attribute double totalVentes;
   * </pre>
   */
  public double totalVentes () {
    return this._delegate.totalVentes();
  }

  /**
   * <pre>
   *   readonly attribute double totalVentesCaissier;
   * </pre>
   */
  public double totalVentesCaissier () {
    return this._delegate.totalVentesCaissier();
  }

  /**
   * <pre>
   *   readonly attribute string nomAgence;
   * </pre>
   */
  public java.lang.String nomAgence () {
    return this._delegate.nomAgence();
  }

  /**
   * <pre>
   *   readonly attribute string nomCaissier;
   * </pre>
   */
  public java.lang.String nomCaissier () {
    return this._delegate.nomCaissier();
  }

  /**
   * <pre>
   *   readonly attribute string nomCaisse;
   * </pre>
   */
  public java.lang.String nomCaisse () {
    return this._delegate.nomCaisse();
  }

  /**
   * <pre>
   *   void vendreS (in string codeBarre)
    raises (agences.supermarche.CaisseException);
   * </pre>
   */
  public void vendreS (java.lang.String codeBarre) throws  agences.supermarche.CaisseException {
    this._delegate.vendreS(codeBarre);
  }

  /**
   * <pre>
   *   void vendreC (in string codeBarre, in long qte)
    raises (agences.supermarche.CaisseException);
   * </pre>
   */
  public void vendreC (java.lang.String codeBarre, 
                       int qte) throws  agences.supermarche.CaisseException {
    this._delegate.vendreC(codeBarre, qte);
  }

  /**
   * <pre>
   *   agences.supermarche.listeTickets editerTicket ()
    raises (agences.supermarche.CaisseException);
   * </pre>
   */
  public agences.supermarche.LigneTicket[] editerTicket () throws  agences.supermarche.CaisseException {
    return this._delegate.editerTicket();
  }

  /**
   * <pre>
   *   string connecter (in string login, in string password)
    raises (agences.supermarche.CaisseException);
   * </pre>
   */
  public java.lang.String connecter (java.lang.String login, 
                                     java.lang.String password) throws  agences.supermarche.CaisseException {
    return this._delegate.connecter(login, password);
  }

  /**
   * <pre>
   *   void deconnecter (in string login, in string password)
    raises (agences.supermarche.CaisseException);
   * </pre>
   */
  public void deconnecter (java.lang.String login, 
                           java.lang.String password) throws  agences.supermarche.CaisseException {
    this._delegate.deconnecter(login, password);
  }

}
