package ihm;

import javax.swing.UIManager;
import java.awt.*;
import agences.supermarche.AgenceHelper;
import agences.supermarche.Agence;
import agences.supermarche.AgenceException;
import agences.supermarche.Caisse;
import org.omg.CosNaming.*;
import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import java.util.*;
import javax.swing.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author
 * @version 1.0
 */

public class ApplicationClienteCaisse {

  private boolean packFrame_ = false;

  public ApplicationClienteCaisse(String[] args) {
    try{
      //code relatif  CORBA
      String nomAgence =   JOptionPane.showInputDialog(
                           null,
                           "Entrez le nom de l'agence : " ,
                           "Gestion des caisses",
                           JOptionPane.QUESTION_MESSAGE);

      System.getProperties().put("SVCnameroot","NameService"+nomAgence);
      // On intialise l'orb
      org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args,System.getProperties());

      //on rcupere en premier lieu la rfrence initiale du service de nommage
      org.omg.CORBA.Object racineObj = orb.resolve_initial_references("NameService");

      //on rcupre ensuite la racine de l'arbre
      NamingContextExt racineArbre = NamingContextExtHelper.narrow(racineObj);

      // On construit le nom  chercher dans l'annuaire, Agence en l'occurrence
      String nomCaisse =   JOptionPane.showInputDialog(
                           null,
                           "Entrez le nom de la caisse  crer : " ,
                           "Gestion des caisses",
                           JOptionPane.QUESTION_MESSAGE);

      org.omg.CosNaming.NameComponent[] nom = new org.omg.CosNaming.NameComponent[2];
      nom[0] = new org.omg.CosNaming.NameComponent(args[2],"designation");
      nom[1] = new org.omg.CosNaming.NameComponent("Agence"+nomAgence,"objet_metier");

      // On recherche la rfrence auprs du naming service
      org.omg.CORBA.Object distant = racineArbre.resolve(nom);

      //casting de l'objet CORBA au type adequat
      Agence monObj = agences.supermarche.AgenceHelper.narrow(distant);

      //creation d'une caisse dedie
      Caisse maCaisse = monObj.creer(nomCaisse);

      //Construit l'IHM
      InterfaceClienteCaisse frame = new InterfaceClienteCaisse(nomCaisse,maCaisse,monObj);

      if (packFrame_) {
        frame.pack();
      }
      else {
        frame.validate();
      }
      //centre la fenetre
      Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
      Dimension frameSize = frame.getSize();
      if (frameSize.height > screenSize.height) {
        frameSize.height = screenSize.height;
      }
      if (frameSize.width > screenSize.width) {
        frameSize.width = screenSize.width;
      }
      frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
      frame.setVisible(true);
    }
    catch(Exception e) {
      e.printStackTrace();
      System.exit(0);
    }
  }

  /**
   * Point d'entre
   */
  public static void main(String[] args) {
    try {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
      new ApplicationClienteCaisse(args);
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

}