package ihm;

import javax.swing.UIManager;
import java.awt.*;
import gererproduits.supermarche.*;
import gererstocks.supermarche.GererStocks;
import gererstocks.supermarche.GererStocksException;
import org.omg.CosNaming.*;
import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import java.util.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author
 * @version 1.0
 */



public class ApplicationClienteSiege {

  private boolean packFrame_ = false;

  public ApplicationClienteSiege(String[] args) {
    try{
      //code relatif  CORBA
      // On intialise l'orb
      org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args,null);

      //on rcupere en premier lieu la rfrence initiale du service de nommage
      org.omg.CORBA.Object racineObj = orb.resolve_initial_references("NameService");

      //on rcupre ensuite la racine de l'arbre
      NamingContextExt racineArbre = NamingContextExtHelper.narrow(racineObj);

      // On construit le nom  chercher dans l'annuaire, GererProduits en premier
      org.omg.CosNaming.NameComponent[] nom = new org.omg.CosNaming.NameComponent[2];
      nom[0] = new org.omg.CosNaming.NameComponent(args[2],"designation");
      nom[1] = new org.omg.CosNaming.NameComponent(args[1],"objet_metier");

      // On recherche la rfrence auprs du naming service
      org.omg.CORBA.Object distant = racineArbre.resolve(nom);

      //casting de l'objet CORBA au type adequat
      GererProduits monObj = gererproduits.supermarche.GererProduitsHelper.narrow(distant);

      //on rcupre la racine de l'arbre de federation
      nom = new org.omg.CosNaming.NameComponent[1];
      nom[0] = new org.omg.CosNaming.NameComponent(args[3],"federation");

      // On recherche la rfrence auprs du naming service
      distant = racineArbre.resolve(nom);

      //casting de l'objet CORBA au type adequat
      NamingContext fede = org.omg.CosNaming.NamingContextHelper.narrow(distant);

      //recuperation des references des objets GererStocks de chaque agence
      BindingIteratorHolder bIterator = new BindingIteratorHolder();
      BindingListHolder bList = new BindingListHolder();
      Hashtable listeGererStocks = new Hashtable();
      int i=0;

      try {
        fede.list(10,bList,bIterator);
      }
      catch (Exception e) {
        System.out.println("Contexte vide");
        return;
      }

      //parcours n premiers elements
      for(i=0;i<bList.value.length;i++) {
        if(!bList.value[i].binding_name[0].id.equals(args[4])) {
          nom = new org.omg.CosNaming.NameComponent[4];
          nom[0] = new org.omg.CosNaming.NameComponent(args[3],"federation");
          nom[1] = new org.omg.CosNaming.NameComponent(bList.value[i].binding_name[0].id,"federation");
          nom[2] = new org.omg.CosNaming.NameComponent(args[2],"designation");
          nom[3] = new org.omg.CosNaming.NameComponent(args[0],"objet_metier");

          try{
            // On recherche la rfrence
            distant = racineArbre.resolve(nom);
          }
          catch (Exception e) {
            System.out.println(args[3]+"/"+bList.value[i].binding_name[0].id+"/"+args[2]+"/"+args[0]+" n'est pas accessible");
          }

          //casting de l'objet CORBA au type adequat
          GererStocks monObj2 = gererstocks.supermarche.GererStocksHelper.narrow(distant);

          listeGererStocks.put(bList.value[i].binding_name[0].id,monObj2);
          System.out.println("Objet GererStocks trouv - Nom:"+bList.value[i].binding_name[0].id+" - Type:"+bList.value[i].binding_name[0].kind);
        }
      }

      //parcours iterateur si besoin
      if(bIterator.value!=null) {
        while(bIterator.value.next_n(10,bList)) {
          for(i=0;i<bList.value.length;i++) {
            if(!bList.value[i].binding_name[0].id.equals(args[4])) {
                nom = new org.omg.CosNaming.NameComponent[4];
                nom[0] = new org.omg.CosNaming.NameComponent(args[3],"federation");
                nom[1] = new org.omg.CosNaming.NameComponent(bList.value[i].binding_name[0].id,"federation");
                nom[2] = new org.omg.CosNaming.NameComponent(args[2],"designation");
                nom[3] = new org.omg.CosNaming.NameComponent(args[0],"objet_metier");

                try{
                  // On recherche la rfrence
                  distant = racineArbre.resolve(nom);
                }
                catch (Exception e) {
                  System.out.println(args[3]+"/"+bList.value[i].binding_name[0].id+"/"+args[2]+"/"+args[0]+" n'est pas accessible");
                }

                //casting de l'objet CORBA au type adequat
                GererStocks monObj2 = gererstocks.supermarche.GererStocksHelper.narrow(distant);

                listeGererStocks.put(bList.value[i].binding_name[0].id,monObj2);
                System.out.println("Objet GererStocks trouv - Nom:"+bList.value[i].binding_name[0].id+" - Type:"+bList.value[i].binding_name[0].kind);
            }
          }
        }
        //destruction iterateur
        bIterator.value.destroy();
      }


      //Construit l'IHM
      InterfaceCliente frame = new InterfaceCliente(monObj,listeGererStocks);

      if (packFrame_) {
        frame.pack();
      }
      else {
        frame.validate();
      }
      //centre la fenetre
      Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
      Dimension frameSize = frame.getSize();
      if (frameSize.height > screenSize.height) {
        frameSize.height = screenSize.height;
      }
      if (frameSize.width > screenSize.width) {
        frameSize.width = screenSize.width;
      }
      frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
      frame.setVisible(true);
    }
    catch(Exception e) {
      e.printStackTrace();
      System.exit(0);
    }
  }

  /**
   * Point d'entre
   */
  public static void main(String[] args) {
    try {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
      new ApplicationClienteSiege(args);
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

}