package ihm;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author
 * @version 1.0
 */

import java.util.Enumeration;
import java.util.Vector;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.border.*;
import agences.supermarche.LigneTicket;

public class InterfaceAgenceVenteEditerTicket extends JPanel
   implements ActionListener, DocumentListener {

  static final String emplacement__ = "ihm.InterfaceAgencesVenteEditerTicket";
  JLabel lblTitre = new JLabel();
  JLabel lblMontant = new JLabel();
  JTextField txtMontant = new JTextField();
  JLabel lblCodeBarre = new JLabel();
  JLabel lblDesignation = new JLabel();
  JLabel lblPrixHT = new JLabel();
  JLabel lblQte = new JLabel();
  JLabel lblPrixTTC = new JLabel();

  /**
   * Contructeur
   */
  public InterfaceAgenceVenteEditerTicket() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }


  /**
   * gestion des actions de l'utilisateur
   */
   public void actionPerformed(ActionEvent evt){
    try {
       java.lang.Object source = evt.getSource();
    }
    catch(Exception e) {
      handleException(e);
    }
   }

   public void insertUpdate(DocumentEvent e){
   }
   public void removeUpdate(DocumentEvent e){
   }
   public void changedUpdate(DocumentEvent e){
   }

  private void jbInit() throws Exception {
    lblTitre.setFont(new java.awt.Font("Dialog", 1, 14));
    lblTitre.setHorizontalAlignment(SwingConstants.CENTER);
    lblTitre.setText("Edition du ticket");
    lblTitre.setBounds(new Rectangle(2, 2, 398, 29));
    this.setLayout(null);
    lblMontant.setText("Montant total :");
    lblMontant.setBounds(new Rectangle(29, 49, 117, 26));
    txtMontant.setBackground(SystemColor.text);
    txtMontant.setEnabled(false);
    txtMontant.setBounds(new Rectangle(149, 45, 222, 30));
    lblCodeBarre.setText("Code barre");
    lblCodeBarre.setBounds(new Rectangle(20, 95, 70, 19));
    lblDesignation.setText("Dsignation");
    lblDesignation.setBounds(new Rectangle(91, 95, 79, 19));
    lblPrixHT.setText("Prix HT");
    lblPrixHT.setBounds(new Rectangle(181, 93, 50, 22));
    lblQte.setText("Quantit");
    lblQte.setBounds(new Rectangle(246, 93, 57, 22));
    lblPrixTTC.setText("Prix TTC");
    lblPrixTTC.setBounds(new Rectangle(315, 93, 53, 23));
    this.add(lblTitre, null);
    this.add(lblMontant, null);
    this.add(txtMontant, null);
    this.add(lblCodeBarre, null);
    this.add(lblDesignation, null);
    this.add(lblPrixHT, null);
    this.add(lblQte, null);
    this.add(lblPrixTTC, null);
}

  /**
   * Affiche l'erreur passe en paramtre dans une boite de dialogue
   */
  private final void handleException(Exception ex) {
    JOptionPane.showMessageDialog(
                       this,
                       "Description : " +ex.toString()+"\n"+
                       "Message : "+ex.getMessage()+"\n"+
                       "Emplacement : "+emplacement__,
                       "Erreur",
                       JOptionPane.ERROR_MESSAGE);
  }

  /**
   * Valorise les paramtres avec les valeurs des champs de l'cran
   */
  public Vector ihm2Data() {
    try{
      Vector data = new Vector();

      return data;
    }
    catch(Exception e) {
      handleException(e);
      return null;
    }
  }

  /**
   * Valorise les champs de l'ihm avec les valeurs en param
   */
  public void data2Ihm(LigneTicket[] lignes) {
    try{
      String[] columnNames = {"Code barre","Dsignation","Prix","Quantit","Montant"};
      Object[][] data = new Object[lignes.length][5];
      JTable lstTicket = new JTable(data,columnNames);
      double montant=0;
      for(int i=0;i<lignes.length;i++) {
        lstTicket.setValueAt(new String(lignes[i].codeBarre),i,0);
        lstTicket.setValueAt(new String(lignes[i].designation) ,i,1);
        lstTicket.setValueAt(new Double(lignes[i].prixTTC),i,2);
        lstTicket.setValueAt(new Integer(lignes[i].qte),i,3);
        lstTicket.setValueAt(new Double(lignes[i].qte*lignes[i].prixTTC),i,4);
        montant+=lignes[i].qte*lignes[i].prixTTC;
      }
      lstTicket.setBackground(Color.white);
      lstTicket.setBorder(BorderFactory.createEtchedBorder());
      lstTicket.setGridColor(Color.black);
      lstTicket.setPreferredScrollableViewportSize(new Dimension(250, 70));
      //lstTicket.setBackground(SystemColor.text);
      lstTicket.setBounds(new Rectangle(14, 110, 375, 225));
      this.add(lstTicket, null);
      txtMontant.setText((new Double(montant)).toString());
      this.repaint();
    }
    catch(Exception e) {
      handleException(e);
    }
  }

  /**
   * Remet  zero le champ de saisie
   */
  public void clear() {
    try{

    }
    catch(Exception e) {
      handleException(e);
    }
  }
}
