package ihm;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author
 * @version 1.0
 */
import gererproduits.supermarche.GererProduits;
import gererproduits.supermarche.GererProduitsException;
import gererproduits.supermarche.Produit;
import gererstocks.supermarche.GererStocks;
import gererstocks.supermarche.GererStocksException;
import gererstocks.supermarche.Stock;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import javax.swing.text.*;
import javax.swing.event.*;
import org.omg.CORBA.*;
import java.util.*;
import java.lang.*;

public class InterfaceCliente extends JFrame
  implements DocumentListener, ActionListener {

  /**
   * Contient le nom de la classe de l'cran affich
   * Permet de retrouver facilement cet cran pour les validations
   */
  private Class ecranCourant;

  private static ORB orb;
  static final String emplacement = "ihm.InterfaceCliente";
  JPanel cadreConteneur;
  JMenuBar menuBarre = new JMenuBar();
  JMenu menuFichier = new JMenu();   //menu Fichier
  JMenuItem menuFichierQuitter = new JMenuItem();
  JMenu menuAide = new JMenu(); // menu Aide
  JMenuItem menuAideAPropos = new JMenuItem();
  JMenu menuProduits = new JMenu(); // menu Gerer Offre Emploi
  JMenuItem menuProduitsConsulter = new JMenuItem();
  JMenu menuGererStocksAgences = new JMenu(); // menu Candidature
  JToolBar outilBarre = new JToolBar();
  JButton jBouttonValider = new JButton();
  JButton jBouttonAnnuler = new JButton();
  JButton jBouttonAPropos = new JButton();
  ImageIcon imageValider;
  ImageIcon imageAnnuler;
  ImageIcon imageAPropos;
  ImageIcon imageAcceuil;
  JLabel image = new JLabel();
  JLabel statusBarre = new JLabel();
  BorderLayout borderLayout = new BorderLayout();
  JScrollPane jScroll = new JScrollPane();


  ButtonGroup group = new ButtonGroup();
  JMenuItem menuProduitsCreer = new JMenuItem();
  JMenuItem menuProduitsModifier = new JMenuItem();
  JMenuItem menuProduitsSupprimer = new JMenuItem();
  JMenuItem menuGererStocksAgencesIncrementer = new JMenuItem();
  JMenuItem menuGererStocksAgencesDecrementer = new JMenuItem();
  JMenuItem menuGererStocksAgencesRechercher = new JMenuItem();

  //reference vers les objets CORBA
  GererProduits iGererProduits;
  Hashtable listeGererStocks;
  JMenuItem menuGererStocksAgencesCreer = new JMenuItem();

  /**
   * Constructeur
   */
  public InterfaceCliente(GererProduits pGererProduits, Hashtable pListeGererStocks) {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      iGererProduits = pGererProduits;
      listeGererStocks = pListeGererStocks;
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
   public void insertUpdate(DocumentEvent e){
   }
   public void removeUpdate(DocumentEvent e){
   }
   public void changedUpdate(DocumentEvent e){
   }

  /**
   * Fermeture de l'application apres clic sur Fermer de la Fenetre
   */
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
        System.exit(0);
    }
  }

  /**
   * Initialisation de l'IHM
   */
  private void jbInit() throws Exception  {
    try {
      imageValider = new ImageIcon(InterfaceCliente.class.getResource("images/check.gif"));
      imageAnnuler = new ImageIcon(InterfaceCliente.class.getResource("images/delete.gif"));
      imageAPropos = new ImageIcon(InterfaceCliente.class.getResource("images/help.gif"));
      cadreConteneur = (JPanel) this.getContentPane();
      cadreConteneur.setLayout(borderLayout);
      this.setResizable(false);
      this.setSize(new Dimension(440, 434));
      this.setTitle("Application CORBA - DESS MIAGe");
      statusBarre.setDisabledIcon(new ImageIcon(InterfaceCliente.class.getResource("images/bt.gif")));
      statusBarre.setText(" ");
      menuFichier.setText("Fichier");
      menuFichier.setMnemonic('F');
      menuFichierQuitter.setText("Quitter");
      menuFichierQuitter.setMnemonic('Q');
      menuFichierQuitter.addActionListener(this);
      menuAide.setText("Aide");
      menuAide.setMnemonic('A');
      menuAideAPropos.setText("A Propos");
      menuAideAPropos.setMnemonic('A');
      menuAideAPropos.addActionListener(this);
      menuProduits.setText("Grer produits");
      menuProduits.setActionCommand("Grer produits");
      menuProduits.setMnemonic('P');
      menuProduitsConsulter.setText("Consulter");
      menuProduitsConsulter.setActionCommand("Rechercher");
      menuProduitsConsulter.setMnemonic('O');
      menuProduitsConsulter.addActionListener(this);
      menuGererStocksAgences.setText("Grer stocks agences");
      menuGererStocksAgences.setActionCommand("Grer stocks agences");
      menuGererStocksAgences.setMnemonic('S');
      jBouttonValider.setIcon(imageValider);
      jBouttonValider.addActionListener(this);
      jBouttonValider.setToolTipText("Valider la saisie");
      jBouttonAnnuler.setIcon(imageAnnuler);
      jBouttonAnnuler.addActionListener(this);
      jBouttonAnnuler.setMinimumSize(new Dimension(51, 27));
      jBouttonAnnuler.setPreferredSize(new Dimension(51, 27));
      jBouttonAnnuler.setToolTipText("Remise  blanc");
      jBouttonAPropos.setIcon(imageAPropos);
      jBouttonAPropos.addActionListener(this);
      jBouttonAPropos.setToolTipText("A Propos");
      menuFichierQuitter.setText("Quitter");
      menuFichierQuitter.addActionListener(this);
      cadreConteneur.setMinimumSize(new Dimension(150, 150));
      cadreConteneur.setPreferredSize(new Dimension(150, 150));
      menuProduitsCreer.setMnemonic('C');
      menuProduitsCreer.setText("Crer");
      menuProduitsModifier.setMnemonic('M');
      menuProduitsModifier.setText("Modifier");
      menuProduitsSupprimer.setMnemonic('S');
      menuProduitsSupprimer.setText("Supprimer");
      menuGererStocksAgencesIncrementer.setMnemonic('I');
      menuGererStocksAgencesIncrementer.setText("Incrmenter");
      menuGererStocksAgencesDecrementer.setMnemonic('D');
      menuGererStocksAgencesDecrementer.setText("Dcrementer");
      menuGererStocksAgencesRechercher.setMnemonic('C');
      menuGererStocksAgencesRechercher.setText("Consulter");
      menuGererStocksAgencesCreer.setMnemonic('R');
      menuGererStocksAgencesCreer.setText("Crer");
      outilBarre.add(jBouttonValider);
      outilBarre.add(jBouttonAnnuler);
      outilBarre.add(jBouttonAPropos);
      menuBarre.add(menuFichier);
      menuBarre.add(menuProduits);
      menuBarre.add(menuGererStocksAgences);
      menuBarre.add(menuAide);
      menuFichier.add(menuFichierQuitter);
      menuAide.add(menuAideAPropos);
      menuProduits.add(menuProduitsCreer);
      menuProduits.add(menuProduitsModifier);
      menuProduits.add(menuProduitsSupprimer);
      menuProduits.add(menuProduitsConsulter);
      this.setJMenuBar(menuBarre);
      cadreConteneur.add(outilBarre, BorderLayout.NORTH);
      cadreConteneur.add(statusBarre, BorderLayout.SOUTH);
      cadreConteneur.add(jScroll, BorderLayout.CENTER);
      menuGererStocksAgences.add(menuGererStocksAgencesCreer);
      menuGererStocksAgences.add(menuGererStocksAgencesIncrementer);
      menuGererStocksAgences.add(menuGererStocksAgencesDecrementer);
      menuGererStocksAgences.add(menuGererStocksAgencesRechercher);
      menuProduitsCreer.addActionListener(this);
      menuProduitsModifier.addActionListener(this);
      menuProduitsSupprimer.addActionListener(this);
      menuProduitsConsulter.addActionListener(this);
      menuGererStocksAgencesRechercher.addActionListener(this);
      menuGererStocksAgencesIncrementer.addActionListener(this);
      menuGererStocksAgencesDecrementer.addActionListener(this);
      menuGererStocksAgencesCreer.addActionListener(this);
    }
    catch(Exception e) {
      handleException(e);
    }
  }

  /**
   * Affichage de l'cran A Propos
   */
  private void aideAPropos() {
    BoiteDeDialogue dlg = new BoiteDeDialogue(this,
                "Bote de dialogue A Propos",
                "Application CORBA - DESS MIAGe Toulouse",
                "Copyright(c) 2001",
                "Cathy Franco - Laetitia Soulie - David Rousse",
                "A Propos ...",
                "images/logoUPS.gif");
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.show();
  }

  /**
   * Affiche l'erreur passe en paramtre dans une boite de dialogue
   */
  private final void handleException(Exception ex) {
    JOptionPane.showMessageDialog(
                       this,
                       "Description : " +ex.toString()+"\n"+
                       "Message : "+ex.getMessage()+"\n"+
                       "Emplacement : "+emplacement,
                       "Erreur",
                       JOptionPane.ERROR_MESSAGE);
  }

  /**
   * gestion des actions de l'utilisateur
   */
   public void actionPerformed(ActionEvent evt){
    try {
       // TRAITEMENT ASSOCIES AUX MENUS
       java.lang.Object source = evt.getSource();

       // Menu Fichier
       if (source == menuFichierQuitter)
          System.exit(0);

       //  Gerer Produits
       // Creer
       if (source == menuProduitsCreer) {
          InterfaceProduitsCreer view = new InterfaceProduitsCreer();
          ecranCourant = view.getClass();
          jScroll.getViewport().add(view, BorderLayout.CENTER);
       }

        if (source == menuProduitsModifier) {
          InterfaceProduitsModifier view = new InterfaceProduitsModifier();
          ecranCourant = view.getClass();
          jScroll.getViewport().add(view, BorderLayout.CENTER);
       }

       if (source == menuProduitsConsulter) {
          InterfaceProduitsConsulter view = new InterfaceProduitsConsulter();
          ecranCourant = view.getClass();
          jScroll.getViewport().add(view, BorderLayout.CENTER);
       }

       if (source == menuProduitsSupprimer) {
          InterfaceProduitsSupprimer view = new InterfaceProduitsSupprimer();
          ecranCourant = view.getClass();
          jScroll.getViewport().add(view, BorderLayout.CENTER);
       }

       // GererStocksAgence
       //consulter
       if (source == menuGererStocksAgencesRechercher) {
          InterfaceGererStocksAgencesRechercher view = new InterfaceGererStocksAgencesRechercher(listeGererStocks);
          ecranCourant = view.getClass();
          jScroll.getViewport().add(view, BorderLayout.CENTER);
       }

       // Creer
       if (source == menuGererStocksAgencesCreer) {
          InterfaceGererStocksAgencesCreer view = new InterfaceGererStocksAgencesCreer(listeGererStocks);
          ecranCourant = view.getClass();
          jScroll.getViewport().add(view, BorderLayout.CENTER);
       }

       // Incrementer
       if (source == menuGererStocksAgencesIncrementer) {
          InterfaceGererStocksAgencesIncrementer view = new InterfaceGererStocksAgencesIncrementer(listeGererStocks);
          ecranCourant = view.getClass();
          jScroll.getViewport().add(view, BorderLayout.CENTER);
       }

       // Incrementer
       if (source == menuGererStocksAgencesDecrementer) {
          InterfaceGererStocksAgencesDecrementer view = new InterfaceGererStocksAgencesDecrementer(listeGererStocks);
          ecranCourant = view.getClass();
          jScroll.getViewport().add(view, BorderLayout.CENTER);
       }

       //Aide
       if (source == menuAideAPropos)
          aideAPropos();

       // TRAITEMENTS ASSOCIES AUX BOUTONS
       if (source == jBouttonAPropos)
          aideAPropos();

       if (source == jBouttonValider) {

          // Creer un produit
          if (ecranCourant.equals(InterfaceProduitsCreer.class)) {

            InterfaceProduitsCreer view = (InterfaceProduitsCreer) jScroll.getViewport().getComponent(0);
            // Rcuperation des donnes de l'cran courant
            Vector data = view.ihm2Data();

            //****************************************************/
            //*  Appel de methode sur le composant GererProduits */
            //****************************************************/
            String code = new String((String)data.elementAt(0));
            String designation = new String((String)data.elementAt(1));
            double prix=((Double)data.elementAt(2)).doubleValue();
            try {
              iGererProduits.creer(code,designation,prix);
              //Confirmation action
              JOptionPane.showMessageDialog(
                           this,
                           "Enregistrement ralis !\nCode barre : "+code+"\nDesignation : "+designation+"\nPrix HT : "+prix ,
                           "Gestion des produits",
                           JOptionPane.INFORMATION_MESSAGE);
            }
            catch(gererproduits.supermarche.GererProduitsException e) {
              handleException(e);
            }
            //effacement donnees sur IHM courante
            view.clear();
          }

          // Modifier un produit
          if (ecranCourant.equals(InterfaceProduitsModifier.class)) {

            InterfaceProduitsModifier view = (InterfaceProduitsModifier) jScroll.getViewport().getComponent(0);
            // Rcuperation des donnes de l'cran courant
            Vector data = view.ihm2Data();

            //****************************************************/
            //*  Appel de methode sur le composant GererProduits */
            //****************************************************/
            String code = new String((String)data.elementAt(0));
            String designation = new String((String)data.elementAt(1));
            double prix=((Double)data.elementAt(2)).doubleValue();
            try {

              iGererProduits.modifier(code,designation,prix);
              //Confirmation action
              JOptionPane.showMessageDialog(
                           this,
                           "Modification ralise !\nCode barre : "+code+"\nDesignation : "+designation+"\nPrix HT : "+prix ,
                           "Gestion des produits",
                           JOptionPane.INFORMATION_MESSAGE);
            }
            catch(gererproduits.supermarche.GererProduitsException e) {
              handleException(e);
            }
            //effacement donnees sur IHM courante
            view.clear();
          }

          // Consulter un produit
          if (ecranCourant.equals(InterfaceProduitsConsulter.class)) {

            InterfaceProduitsConsulter view = (InterfaceProduitsConsulter) jScroll.getViewport().getComponent(0);
            // Rcuperation des donnes de l'cran courant
            Vector data = view.ihm2Data();

            //****************************************************/
            //*  Appel de methode sur le composant GererProduits */
            //****************************************************/
            String code = new String((String)data.elementAt(0));
            try {
              Produit p = iGererProduits.rechercher(code);
              //Resultat affich  l'cran
              view.data2Ihm(p.designation,(new Double(p.prixHT)).toString());
            }
            catch(gererproduits.supermarche.GererProduitsException e) {
              handleException(e);
            }
          }

          // Supprimer un produit
          if (ecranCourant.equals(InterfaceProduitsSupprimer.class)) {

            InterfaceProduitsSupprimer view = (InterfaceProduitsSupprimer) jScroll.getViewport().getComponent(0);
            // Rcuperation des donnes de l'cran courant
            Vector data = view.ihm2Data();

            //****************************************************/
            //*  Appel de methode sur le composant GererProduits */
            //****************************************************/
            String code = new String((String)data.elementAt(0));
            try {
              iGererProduits.supprimer(code);
              //Confirmation action
              JOptionPane.showMessageDialog(
                           this,
                           "Suppression ralise !\nCode barre : "+code ,
                           "Gestion des produits",
                           JOptionPane.INFORMATION_MESSAGE);
            }
            catch(gererproduits.supermarche.GererProduitsException e) {
              handleException(e);
            }
            //effacement donnees sur IHM courante
            view.clear();
          }

          // Consulter un stock d'une agence
          if (ecranCourant.equals(InterfaceGererStocksAgencesRechercher.class)) {

            InterfaceGererStocksAgencesRechercher view = (InterfaceGererStocksAgencesRechercher) jScroll.getViewport().getComponent(0);
            // Rcuperation des donnes de l'cran courant
            Vector data = view.ihm2Data();

            //recuperation de la reference locale de l'objet distant
            GererStocks iGererStocks = (GererStocks)listeGererStocks.get(data.elementAt(0));

            //****************************************************/
            //*  Appel de methode sur le composant GererStocks */
            //****************************************************/
            String code = new String((String)data.elementAt(1));
            try {
              Stock s = iGererStocks.rechercher(code);
              //Resultat affich  l'cran
              view.data2Ihm((new Integer(s.qte)).toString());
            }
            catch(gererstocks.supermarche.GererStocksException e) {
              handleException(e);
            }
          }

          // Creer un stock d'une agence
          if (ecranCourant.equals(InterfaceGererStocksAgencesCreer.class)) {

            InterfaceGererStocksAgencesCreer view = (InterfaceGererStocksAgencesCreer) jScroll.getViewport().getComponent(0);
            // Rcuperation des donnes de l'cran courant
            Vector data = view.ihm2Data();

            //recuperation de la reference locale de l'objet distant
            GererStocks iGererStocks = (GererStocks)listeGererStocks.get(data.elementAt(0));

            //****************************************************/
            //*  Appel de methode sur le composant GererStocks */
            //****************************************************/
            String code = new String((String)data.elementAt(1));
            int qte = (new Integer((String)data.elementAt(2))).intValue();
            try {
              iGererStocks.creer(code,qte);
              JOptionPane.showMessageDialog(
               this,
               "Cration ralise !\nCode barre : "+code+"\nQuantit : "+qte ,
               "Gestion des stocks",
               JOptionPane.INFORMATION_MESSAGE);
            }
            catch(gererstocks.supermarche.GererStocksException e) {
              handleException(e);
            }
            //effacement donnees sur IHM courante
            view.clear();
          }

          // Incrementer un stock d'une agence
          if (ecranCourant.equals(InterfaceGererStocksAgencesIncrementer.class)) {

            InterfaceGererStocksAgencesIncrementer view = (InterfaceGererStocksAgencesIncrementer) jScroll.getViewport().getComponent(0);
            // Rcuperation des donnes de l'cran courant
            Vector data = view.ihm2Data();

            //recuperation de la reference locale de l'objet distant
            GererStocks iGererStocks = (GererStocks)listeGererStocks.get(data.elementAt(0));

            //****************************************************/
            //*  Appel de methode sur le composant GererStocks */
            //****************************************************/
            String code = new String((String)data.elementAt(1));
            int qte = (new Integer((String)data.elementAt(2))).intValue();
            try {
              iGererStocks.incrementer(code,qte);
              JOptionPane.showMessageDialog(
               this,
               "Incrmentation ralise !\nCode barre : "+code+"\nQuantit ajoute: "+qte ,
               "Gestion des stocks",
               JOptionPane.INFORMATION_MESSAGE);
            }
            catch(gererstocks.supermarche.GererStocksException e) {
              handleException(e);
            }
            //effacement donnees sur IHM courante
            view.clear();
          }

          // Decrementer un stock d'une agence
          if (ecranCourant.equals(InterfaceGererStocksAgencesDecrementer.class)) {

            InterfaceGererStocksAgencesDecrementer view = (InterfaceGererStocksAgencesDecrementer) jScroll.getViewport().getComponent(0);
            // Rcuperation des donnes de l'cran courant
            Vector data = view.ihm2Data();

            //recuperation de la reference locale de l'objet distant
            GererStocks iGererStocks = (GererStocks)listeGererStocks.get(data.elementAt(0));

            //****************************************************/
            //*  Appel de methode sur le composant GererStocks */
            //****************************************************/
            String code = new String((String)data.elementAt(1));
            int qte = (new Integer((String)data.elementAt(2))).intValue();
            try {
              iGererStocks.decrementer(code,qte);
              JOptionPane.showMessageDialog(
               this,
               "Decrmentation ralise !\nCode barre : "+code+"\nQuantit decrmente: "+qte ,
               "Gestion des stocks",
               JOptionPane.INFORMATION_MESSAGE);
            }
            catch(gererstocks.supermarche.GererStocksException e) {
              handleException(e);
            }
            //effacement donnees sur IHM courante
            view.clear();
          }

      }//fin bouton Valider


       if (source == jBouttonAnnuler) {
          //affichage d'une boite de dialogue avec un message d'erreur
          JOptionPane.showMessageDialog(
                         this,
                         "Code nom implment ...",
                         "Dbord !",
                         JOptionPane.ERROR_MESSAGE);
       }

    }
    catch(Exception e) {
      handleException(e);
    }
   }

}


