package ihm;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author
 * @version 1.0
 */
import agences.supermarche.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import javax.swing.text.*;
import javax.swing.event.*;
import org.omg.CORBA.*;
import java.util.*;
import java.lang.*;

public class InterfaceClienteCaisse extends JFrame
  implements DocumentListener, ActionListener {

  /**
   * Contient le nom de la classe de l'cran affich
   * Permet de retrouver facilement cet cran pour les validations
   */
  private Class ecranCourant;

  private static ORB orb;
  static final String emplacement = "ihm.InterfaceClienteCaisse";
  JPanel cadreConteneur;
  JMenuBar menuBarre = new JMenuBar();
  JMenu menuFichier = new JMenu();   //menu Fichier
  JMenuItem menuFichierQuitter = new JMenuItem();
  JMenu menuAide = new JMenu(); // menu Aide
  JMenuItem menuAideAPropos = new JMenuItem();
  JMenu menuVentes = new JMenu(); // menu Gerer Offre Emploi
  JMenu menuEtats = new JMenu(); // menu Candidature
  JToolBar outilBarre = new JToolBar();
  JButton jBouttonValider = new JButton();
  JButton jBouttonAnnuler = new JButton();
  JButton jBouttonAPropos = new JButton();
  ImageIcon imageValider;
  ImageIcon imageAnnuler;
  ImageIcon imageAPropos;
  ImageIcon imageAcceuil;
  JLabel image = new JLabel();
  JLabel statusBarre = new JLabel();
  BorderLayout borderLayout = new BorderLayout();
  JScrollPane jScroll = new JScrollPane();


  ButtonGroup group = new ButtonGroup();
  JMenuItem menuVentesSimple = new JMenuItem();
  JMenuItem menuVentesCompliquee = new JMenuItem();
  JMenuItem menuVentesEditerTicket = new JMenuItem();

  //reference vers les objets CORBA
  Caisse _iCaisse;
  Agence _iAgence;
  String _nomCaisse;
  JMenuItem menuEtatsCaissier = new JMenuItem();
  JMenuItem menuFichierConnecter = new JMenuItem();
  JMenuItem menuFichierDeconnecter = new JMenuItem();
  JMenuItem menuEtatsAgence = new JMenuItem();

  /**
   * Constructeur
   */
  public InterfaceClienteCaisse(String pNomCaisse, Caisse pCaisse, Agence pAgence) {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      _iCaisse = pCaisse;
      _iAgence = pAgence;
      _nomCaisse = pNomCaisse;
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
   public void insertUpdate(DocumentEvent e){
   }
   public void removeUpdate(DocumentEvent e){
   }
   public void changedUpdate(DocumentEvent e){
   }

  /**
   * Fermeture de l'application apres clic sur Fermer de la Fenetre
   */
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
        System.exit(0);
    }
  }

  /**
   * Initialisation de l'IHM
   */
  private void jbInit() throws Exception  {
    try {
      imageValider = new ImageIcon(InterfaceCliente.class.getResource("images/check.gif"));
      imageAnnuler = new ImageIcon(InterfaceCliente.class.getResource("images/delete.gif"));
      imageAPropos = new ImageIcon(InterfaceCliente.class.getResource("images/help.gif"));
      cadreConteneur = (JPanel) this.getContentPane();
      cadreConteneur.setLayout(borderLayout);
      this.setResizable(false);
      this.setSize(new Dimension(440, 434));
      this.setTitle("Application CORBA - DESS MIAGe");
      statusBarre.setDisabledIcon(new ImageIcon(InterfaceCliente.class.getResource("images/bt.gif")));
      statusBarre.setText(_nomCaisse);
      menuFichier.setText("Fichier");
      menuFichier.setMnemonic('F');
      menuFichierQuitter.setText("Quitter");
      menuFichierQuitter.setMnemonic('Q');
      menuFichierQuitter.addActionListener(this);
      menuAide.setText("Aide");
      menuAide.setMnemonic('A');
      menuAideAPropos.setText("A Propos");
      menuAideAPropos.setMnemonic('A');
      menuAideAPropos.addActionListener(this);
      menuVentes.setText("Ventes");
      menuVentes.setEnabled(false);
      menuVentes.setActionCommand("Ventes");
      menuVentes.setMnemonic('V');
      menuEtats.setText("Etats");
      menuEtats.setEnabled(false);
      menuEtats.setActionCommand("Grer stocks agences");
      menuEtats.setMnemonic('E');
      jBouttonValider.setIcon(imageValider);
      jBouttonValider.addActionListener(this);
      jBouttonValider.setToolTipText("Valider la saisie");
      jBouttonAnnuler.setIcon(imageAnnuler);
      jBouttonAnnuler.addActionListener(this);
      jBouttonAnnuler.setMinimumSize(new Dimension(51, 27));
      jBouttonAnnuler.setPreferredSize(new Dimension(51, 27));
      jBouttonAnnuler.setToolTipText("Remise  blanc");
      jBouttonAPropos.setIcon(imageAPropos);
      jBouttonAPropos.addActionListener(this);
      jBouttonAPropos.setToolTipText("A Propos");
      menuFichierQuitter.setText("Quitter");
      menuFichierQuitter.addActionListener(this);
      cadreConteneur.setMinimumSize(new Dimension(150, 150));
      cadreConteneur.setPreferredSize(new Dimension(150, 150));
      menuVentesSimple.setMnemonic('V');
      menuVentesSimple.setText("Vente simple");
      menuVentesCompliquee.setMnemonic('M');
      menuVentesCompliquee.setText("Vente multiple");
      menuVentesEditerTicket.setMnemonic('E');
      menuVentesEditerTicket.setText("Editer ticket");
      menuEtatsCaissier.setMnemonic('T');
      menuEtatsCaissier.setText("Total ventes du caissier");
      menuFichierConnecter.setMnemonic('C');
      menuFichierConnecter.setText("Connecter");
      menuFichierDeconnecter.setMnemonic('D');
      menuFichierDeconnecter.setText("Deconnecter");
      menuEtatsAgence.setMnemonic('V');
      menuEtatsAgence.setText("Total ventes de l\'agence");
      outilBarre.add(jBouttonValider);
      outilBarre.add(jBouttonAnnuler);
      outilBarre.add(jBouttonAPropos);
      menuBarre.add(menuFichier);
      menuBarre.add(menuVentes);
      menuBarre.add(menuEtats);
      menuBarre.add(menuAide);
      menuFichier.add(menuFichierConnecter);
      menuFichier.add(menuFichierDeconnecter);
      menuFichier.add(menuFichierQuitter);
      menuAide.add(menuAideAPropos);
      menuVentes.add(menuVentesSimple);
      menuVentes.add(menuVentesCompliquee);
      menuVentes.add(menuVentesEditerTicket);

      this.setJMenuBar(menuBarre);
      cadreConteneur.add(outilBarre, BorderLayout.NORTH);
      cadreConteneur.add(statusBarre, BorderLayout.SOUTH);
      cadreConteneur.add(jScroll, BorderLayout.CENTER);
      menuEtats.add(menuEtatsCaissier);
      menuEtats.add(menuEtatsAgence);
      menuVentesSimple.addActionListener(this);
      menuVentesCompliquee.addActionListener(this);
      menuVentesEditerTicket.addActionListener(this);
      menuEtatsCaissier.addActionListener(this);
      menuFichierConnecter.addActionListener(this);
      menuFichierDeconnecter.addActionListener(this);
      menuEtatsAgence.addActionListener(this);
    }
    catch(Exception e) {
      handleException(e);
    }
  }

  /**
   * Affichage de l'cran A Propos
   */
  private void aideAPropos() {
    BoiteDeDialogue dlg = new BoiteDeDialogue(this,
                "Bote de dialogue A Propos",
                "Application CORBA - DESS MIAGe Toulouse",
                "Copyright(c) 2001",
                "Cathy Franco - Laetitia Soulie - David Rousse",
                "A Propos ...",
                "images/logoUPS.gif");
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.show();
  }

  /**
   * Affiche l'erreur passe en paramtre dans une boite de dialogue
   */
  private final void handleException(Exception ex) {
    JOptionPane.showMessageDialog(
                       this,
                       "Description : " +ex.toString()+"\n"+
                       "Message : "+ex.getMessage()+"\n"+
                       "Emplacement : "+emplacement,
                       "Erreur",
                       JOptionPane.ERROR_MESSAGE);
  }

  /**
   * gestion des actions de l'utilisateur
   */
   public void actionPerformed(ActionEvent evt){
    try {
       // TRAITEMENT ASSOCIES AUX MENUS
       java.lang.Object source = evt.getSource();

       // Menu Fichier
       if (source == menuFichierQuitter)
          System.exit(0);

       if (source == menuFichierConnecter) {
          InterfaceAgencesFichierConnecter view = new InterfaceAgencesFichierConnecter();
          ecranCourant = view.getClass();
          jScroll.getViewport().add(view, BorderLayout.CENTER);
       }

       if (source == menuFichierDeconnecter) {
          InterfaceAgencesFichierDeconnecter view = new InterfaceAgencesFichierDeconnecter();
          ecranCourant = view.getClass();
          jScroll.getViewport().add(view, BorderLayout.CENTER);
       }


       if (source == menuVentesSimple) {
          InterfaceAgencesVenteSimple view = new InterfaceAgencesVenteSimple();
          ecranCourant = view.getClass();
          jScroll.getViewport().add(view, BorderLayout.CENTER);
       }

        if (source == menuVentesCompliquee) {
          InterfaceAgencesVenteCompliquee view = new InterfaceAgencesVenteCompliquee();
          ecranCourant = view.getClass();
          jScroll.getViewport().add(view, BorderLayout.CENTER);
       }

       if (source == menuVentesEditerTicket) {
          InterfaceAgenceVenteEditerTicket view = new InterfaceAgenceVenteEditerTicket();
          ecranCourant = view.getClass();
          jScroll.getViewport().add(view, BorderLayout.CENTER);
          view = (InterfaceAgenceVenteEditerTicket) jScroll.getViewport().getComponent(0);

          //****************************************************/
          //*  Appel de methode sur le composant Caisse        */
          //****************************************************/

          try {
            LigneTicket[] t = _iCaisse.editerTicket();
            //Confirmation action
            JOptionPane.showMessageDialog(
                         this,
                         "Vente termine pour le client courant !" ,
                         "Gestion des caisses",
                         JOptionPane.INFORMATION_MESSAGE);
          //maj IHM courante
          view.data2Ihm(t);
          }
          catch(agences.supermarche.CaisseException e) {
            handleException(e);
          }

       }

       // Etats
       //consulter
       if (source == menuEtatsCaissier) {
          InterfaceAgencesEtatsCaissier view = new InterfaceAgencesEtatsCaissier();
          ecranCourant = view.getClass();
          jScroll.getViewport().add(view, BorderLayout.CENTER);
       }

       if (source == menuEtatsAgence) {
          InterfaceAgencesEtatsAgence view = new InterfaceAgencesEtatsAgence();
          ecranCourant = view.getClass();
          jScroll.getViewport().add(view, BorderLayout.CENTER);
       }

       //Aide
       if (source == menuAideAPropos)
          aideAPropos();

       // TRAITEMENTS ASSOCIES AUX BOUTONS
       if (source == jBouttonAPropos)
          aideAPropos();

       if (source == jBouttonValider) {

          if (ecranCourant.equals(InterfaceAgencesFichierConnecter.class)) {

            InterfaceAgencesFichierConnecter view = (InterfaceAgencesFichierConnecter) jScroll.getViewport().getComponent(0);
            // Rcuperation des donnes de l'cran courant
            Vector data = view.ihm2Data();

            //****************************************************/
            //*  Appel de methode sur le composant Caisse        */
            //****************************************************/
            String login = new String((String)data.elementAt(0));
            String password = new String((String)data.elementAt(1));
            try {
              String droit = _iCaisse.connecter(login,password);
              //Confirmation action
              JOptionPane.showMessageDialog(
                           this,
                           "Connexion ralise !\nLogin : "+login ,
                           "Gestion des caisses",
                           JOptionPane.INFORMATION_MESSAGE);
              this.setTitle(this.getTitle()+" - "+login);
              this.menuVentes.setEnabled(true);
              this.menuEtats.setEnabled(true);
              //verification des droits
              if(droit.equals("Caissier"))
                menuEtatsAgence.setEnabled(false);
              this.repaint();
            }
            catch(agences.supermarche.CaisseException e) {
              handleException(e);
            }
            //effacement donnees sur IHM courante
            view.clear();
          }

          if (ecranCourant.equals(InterfaceAgencesFichierDeconnecter.class)) {

            InterfaceAgencesFichierDeconnecter view = (InterfaceAgencesFichierDeconnecter) jScroll.getViewport().getComponent(0);
            // Rcuperation des donnes de l'cran courant
            Vector data = view.ihm2Data();

            //****************************************************/
            //*  Appel de methode sur le composant Caisse        */
            //****************************************************/
            String login = new String((String)data.elementAt(0));
            String password = new String((String)data.elementAt(1));
            try {
              _iCaisse.deconnecter(login,password);
              //Confirmation action
              JOptionPane.showMessageDialog(
                           this,
                           "Deconnexion ralise !\nLogin : "+login ,
                           "Gestion des caisses",
                           JOptionPane.INFORMATION_MESSAGE);
              this.setTitle("Application CORBA - DESS MIAGe");
              this.menuVentes.setEnabled(false);
              this.menuEtats.setEnabled(false);
              this.menuEtatsAgence.setEnabled(true);
            }
            catch(agences.supermarche.CaisseException e) {
              handleException(e);
            }
            //effacement donnees sur IHM courante
            view.clear();
          }

          if (ecranCourant.equals(InterfaceAgencesVenteSimple.class)) {

            InterfaceAgencesVenteSimple view = (InterfaceAgencesVenteSimple) jScroll.getViewport().getComponent(0);
            // Rcuperation des donnes de l'cran courant
            Vector data = view.ihm2Data();

            //****************************************************/
            //*  Appel de methode sur le composant Caisse        */
            //****************************************************/
            String code = new String((String)data.elementAt(0));
            try {
              _iCaisse.vendreS(code);
              //Confirmation action
              JOptionPane.showMessageDialog(
                           this,
                           "Vente ralise !\ncode barre : "+code ,
                           "Gestion des caisses",
                           JOptionPane.INFORMATION_MESSAGE);
            }
            catch(agences.supermarche.CaisseException e) {
              handleException(e);
            }
            //effacement donnees sur IHM courante
            view.clear();
          }

          if (ecranCourant.equals(InterfaceAgencesVenteCompliquee.class)) {

            InterfaceAgencesVenteCompliquee view = (InterfaceAgencesVenteCompliquee) jScroll.getViewport().getComponent(0);
            // Rcuperation des donnes de l'cran courant
            Vector data = view.ihm2Data();

            //****************************************************/
            //*  Appel de methode sur le composant Caisse        */
            //****************************************************/
            String code = new String((String)data.elementAt(0));
            String qte = new String((String)data.elementAt(1));
            try {
              _iCaisse.vendreC(code,(new Integer(qte)).intValue());
              //Confirmation action
              JOptionPane.showMessageDialog(
                           this,
                           "Vente ralise !\nCode barre : "+code+"\nQuantit : "+qte ,
                           "Gestion des caisses",
                           JOptionPane.INFORMATION_MESSAGE);
            }
            catch(agences.supermarche.CaisseException e) {
              handleException(e);
            }
            //effacement donnees sur IHM courante
            view.clear();
          }


          if (ecranCourant.equals(InterfaceAgenceVenteEditerTicket.class)) {

          }

          if (ecranCourant.equals(InterfaceAgencesEtatsCaissier.class)) {

            InterfaceAgencesEtatsCaissier view = (InterfaceAgencesEtatsCaissier) jScroll.getViewport().getComponent(0);

            //****************************************************/
            //*  Appel de methode sur le composant Caisse        */
            //****************************************************/
            try {
              double total = _iCaisse.totalVentesCaissier();
              view.data2Ihm(total);
            }
            catch(Exception e) {
              handleException(e);
            }
          }

          if (ecranCourant.equals(InterfaceAgencesEtatsAgence.class)) {

            InterfaceAgencesEtatsAgence view = (InterfaceAgencesEtatsAgence) jScroll.getViewport().getComponent(0);
            // Rcuperation des donnes de l'cran courant
            Vector data = view.ihm2Data();

            //****************************************************/
            //*  Appel de methode sur le composant Caisse        */
            //****************************************************/
            String code = new String((String)data.elementAt(0));
            try {
              double montantTotal = 0.0;
              Caisse[] tabCaisse = _iAgence.listeC();
              for(int i=0;i<tabCaisse.length;i++)
                montantTotal+=tabCaisse[i].totalVentes();

              view.data2Ihm(montantTotal);
            }
            catch(Exception e) {
              handleException(e);
            }
          }

        }//fin bouton Valider


       if (source == jBouttonAnnuler) {
          //affichage d'une boite de dialogue avec un message d'erreur
          JOptionPane.showMessageDialog(
                         this,
                         "Code nom implment ...",
                         "Dbord !",
                         JOptionPane.ERROR_MESSAGE);
       }

    }
    catch(Exception e) {
      handleException(e);
    }
   }

}


